//Asserturi de 100p

#include <vector>
#include <string> 
#include <set> 
#include <map> 
#include <unordered_set>
#include <unordered_map>
#include <queue> 
#include <bitset> 
#include <stack>
#include <list>

#include <numeric> 
#include <algorithm> 
#include <random>
#include <chrono>

#include <cstdio>
#include <fstream>
#include <iostream> 
#include <sstream> 
#include <iomanip>
#include <climits>

#include <cctype>
#include <cmath> 
#include <ctime>
#include <cassert>

using namespace std;

#define ULL unsigned long long
#define LL long long
#define PII pair <int, int>
#define VB vector <bool>
#define VI vector <int>
#define VLL vector <LL>
#define VD vector <double>
#define VS vector <string>
#define VPII vector <pair <int, int> >
#define VVI vector < VI >
#define VVB vector < VB >
#define SI set < int >
#define USI unordered_set <int>
#define MII map <int, int>
#define UMII unordered_map <int, int>
#define MS multiset
#define US unordered_set
#define UM unordered_map
#define UMS unordered_multiset
#define UMM unordered_multimap

#define FORN(i, n) for(int i = 0; i < (n); ++i)
#define FOR(i, a, b) for(int i = (a); i <= (b); ++i)
#define FORD(i, a, b) for(int i = (a); i >= (b); --i)

#define SZ size()
#define BG begin() 
#define EN end() 
#define CL clear()
#define X first
#define Y second
#define RS resize
#define PB push_back
#define ALL(x) x.begin(), x.end()
#define INS insert
#define ER erase
#define CNT count

#define IN_FILE "premii.in"
#define OUT_FILE "premii.out"

template <typename T>
void PR(T var1)
{
	cout << var1 << endl;
}
template <typename T, typename... Types>
void PR(T var1, Types... var2)
{
	cout << var1;
	PR(var2...);
}

#define SHIFT 25000

int n, sum = 0;
VI a;
VVI dp, p;

int main()
{
	freopen(IN_FILE, "r", stdin);
	freopen(OUT_FILE, "w", stdout);

	cin >> n;
	assert(1 <= n && n <= 1000);
	a.RS(n + 1);
	FOR(i, 1, n)
	{
		cin >> a[i];
		assert(a[i] > 0);
		sum += a[i];
	}
	assert(sum <= 50000);

	dp.RS(n + 1, VI(SHIFT * 2 + 1, -1));
	p.RS(n + 1, VI(SHIFT * 2 + 1));
	dp[0][SHIFT] = 0;
	FOR(i, 1, n)
		FOR(j, 0, SHIFT * 2)
		{
			dp[i][j] = dp[i - 1][j];
			p[i][j] = p[i - 1][j];
			int s = j - a[i];
			if (s >= 0 && s <= 2 * SHIFT && dp[i - 1][s] != -1) 
			{
				int aux = dp[i - 1][s] + a[i];
				if (dp[i][j] < aux)
				{
					dp[i][j] = aux;
					p[i][j] = i;
				}
			}
			s = j + a[i];
			if (s >= 0 && s <= 2 * SHIFT && dp[i - 1][s] != -1)
			{
				int aux = dp[i - 1][s] + a[i];
				if (dp[i][j] < aux)
				{
					dp[i][j] = aux;
					p[i][j] = -i;
				}
			}
		}

	PR(sum - dp[n][SHIFT]);
	VI a1, a2;
	int i = n, j = SHIFT;
	while (p[i][j])
	{
		int aux = p[i][j];
		if (aux > 0) 
		{
			a1.PB(aux);
			j -= a[aux];
			i = aux - 1;
		}
		else 
		{
			a2.PB(-aux);
			j += a[-aux];
			i = -aux - 1;
		}
	}

	cout << a1.SZ << endl;
	for (int i : a1) cout << i << " ";
	cout << endl;
	cout << a2.SZ << endl;
	for (int i : a2) cout << i << " ";
	cout << endl;

	return 0;
}